﻿using Excel=Microsoft.Office.Interop.Excel;
using System;

namespace pachExcelNet
{
    public class pachExcelNet :IDisposable
    {
        
        private Excel.Application _ExcelApp;
        private Excel._Workbook _ExcelWorkBook;
        private Excel._Worksheet _ExcelSheet;
        private Excel.Range _ExcelRng;

        
        object m = System.Reflection.Missing.Value;
        
        public pachExcelNet(bool showExcel){
            _ExcelApp  = new Excel.Application();
            _ExcelApp.Visible = showExcel ;


        }

        public void CreateWorkBook(string FilePath)
        {
            _ExcelWorkBook = (Excel._Workbook)(_ExcelApp.Workbooks.Add(System.Reflection.Missing.Value));
            _ExcelWorkBook.SaveAs(FilePath, Excel.XlFileFormat.xlExcel9795,m, m, m, m, Excel.XlSaveAsAccessMode.xlNoChange , m, m, m, m, m);
            _ExcelWorkBook.Close(m,m,m);
                      
        }

        public void OpenWorkBook(string FilePath)
        {
            _ExcelWorkBook = _ExcelApp.Workbooks.Open(FilePath , m, m,m, m, m, m, m, m, m, m, m, m, m, m);
            

        }

        public void ActivateSheet(string Sheet)
        {

            _ExcelSheet = (Excel._Worksheet)_ExcelWorkBook.Sheets[Sheet];
        }

        public string  ReadCell(int Col, int Row)
        {
            _ExcelRng = (Excel.Range)_ExcelSheet.Cells[Row, Col];

            if (_ExcelRng.Value2 != null)
            {
                return _ExcelRng.Value2.ToString();
            }
            else return "" ;
        }
        public void  WriteCell(int Col, int Row,string Value, bool IsText )
        {
            if (IsText)
            {
                _ExcelRng = (Excel.Range)_ExcelSheet.Cells[Row, Col];
                _ExcelRng.NumberFormat = "@";
            }
            _ExcelSheet.Cells[Row, Col]= Value;
            
        }

        public void CloseWorkBook(bool SaveChanges)
        {
            if (SaveChanges)
            {
                _ExcelWorkBook.Save();
            }
            _ExcelWorkBook.Close(m, m, m);
        }

        public void Dispose()
        {
            try
            {
                _ExcelApp.Quit();
            }
            finally { };

        }
    }
}
